/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: basemutex.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: hr $ $Date: 2005/10/27 17:13:27 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _CPPUHELPER_BASEMUTEX_HXX_
#define _CPPUHELPER_BASEMUTEX_HXX_

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

namespace cppu
{
    /** base class for all classes who want derive from
	 ::cppu::WeakComponentImplHelperXX.
	 
	 Implmentation classes have first to derive from BaseMutex and then from
	 ::cppu::WeakComponentImplHelperXX to ensure that the BaseMutex is completely
	 initialized when the mutex is used to intialize the
	 ::cppu::WeakComponentImplHelperXX
    */
	class BaseMutex
	{
	protected:
		mutable ::osl::Mutex m_aMutex;
	};
}
#endif // _CPPUHELPER_BASEMUTEX_HXX_
